#include <cstdlib>
#include <iostream>
#include <list>
#include <fstream>
#include <string>
#include <vector>

using namespace std;

class bank_account {

private:  
   char* code_;
   char* holder_name_;
   vector<double> commitments_; 
   vector<double> withdraws_;
   
  
public:   
    bank_account() {
      code_ = "";
      holder_name_ = "";
   }   
   
   bank_account(char* code, char* holder_name) {
      code_ = code;
      holder_name_ = holder_name;
   }       
   
   ~bank_account() {
     commitments_.clear();  
     withdraws_.clear();
   }
   
   void setCode(char* code) {
      code_ = code;
   }
   
   void setHolderName(char* holder) {
      holder_name_ = holder;
   }
   
   char* getCode() {
      return code_;
   }
   
   char* getHolderName() {
      return holder_name_;
   }
   
   void submit(double money) {
      if(money > 0) {
        commitments_.push_back(money);  
      }
   }
   
   void withdraw(double money) {
      if(money > 0) {
         withdraws_.push_back(money);  
      }
   }
   
   vector<double> getCommitments() {
      return commitments_;
   }
   
   vector<double> getWithdraws() {
      return withdraws_;
   }
   
   friend ostream& operator<<(ostream &out, const bank_account &b) // its friendly so that it can access the private variables
   {
      out << "(";
      out << b.code_;
      out << ")(";
      out << b.holder_name_;
      out << ")";
      out << "(";
      for (vector<double>::const_iterator i = b.commitments_.begin(); i != b.commitments_.end(); ++i) {
         out << *i << " ";
      }
      out << ")";
      out << "(";
      for (vector<double>::const_iterator i = b.withdraws_.begin(); i != b.withdraws_.end(); ++i) {
         out << *i << " ";
      }
      out << ");";
      out << endl;
      return out;
   }
   
};

int main(int argc, char *argv[])
{
   
   vector<bank_account> accounts;
   
   bank_account a("L23456", "Petko Petkov");
   a.submit(20);
   a.submit(20);
   a.submit(5);
   a.withdraw(40);
   a.submit(50);
   a.withdraw(55);
   
   bank_account b("L12345", "Ivan Ivanov");
   b.submit(10);
   b.submit(20);
   b.submit(50);
   b.withdraw(5);

   bank_account c("L03456", "Pesho Petkov");
   c.submit(10);
   c.submit(20);
   c.submit(500);
   c.withdraw(100);
   
   bank_account d("L00456", "Petko Petkov");
   d.submit(20);
   d.submit(20);
   d.submit(5);
   d.withdraw(10);
   d.submit(50);
   
   bank_account e("L00456", "Ivan Ivanov");
   e.submit(20);
   e.submit(20);
   e.submit(5);
   e.withdraw(10);
   e.submit(50);
   
   accounts.push_back(a);
   accounts.push_back(b);
   accounts.push_back(c);
   accounts.push_back(d);
   accounts.push_back(e);
   
   vector<bank_account> v = accounts;
   
   // *****     **********************************************
   ofstream out("bank accounts.txt");
   for (vector<bank_account>::const_iterator ci = accounts.begin(); ci != accounts.end(); ++ci) {
      bank_account b = *ci;
      out << b;
   }
   out.close();

   // ***************************************************************************

   // *****          ********
   vector<char*> h;
   
   for (vector<bank_account>::const_iterator ci = accounts.begin(); ci != accounts.end(); ++ci) {
      bank_account b = *ci;
      h.push_back(b.getHolderName());
   }
   
   for(unsigned i = 0; i < h.size()-1; i++) {
      for(unsigned j = i+1; j < h.size(); j++) {
         if(strcmp(h.at(i), h.at(j))>0) {
            char* tmp = h.at(i);
            h.at(i) = h.at(j);
            h.at(j) = tmp;
         }
      }  
   }
   
   cout << endl << "The card holders of more than one card are: " << endl;
   for(unsigned i = 0; i < h.size()-1; i++) {
      for(unsigned j = i+1; j < h.size(); j++) {
         if(strcmp(h.at(i), h.at(j))==0) {
            cout << h.at(i) << endl;  
         }
      }  
   }
   //****************************************************************************

   // *****           *******
   cout << endl << "The availability of each account is: " << endl;
   for(unsigned j = 0; j < v.size(); j++) {
      bank_account b = v.at(j);
      double sum = 0;
      
      for(unsigned i = 0; i < b.getCommitments().size(); i++) {
         sum += b.getCommitments().at(i);
      }
      for(unsigned i = 0; i < b.getWithdraws().size(); i++) {
         sum -= b.getWithdraws().at(i);
      } 
      cout << b.getCode() << " " << b.getHolderName() << " has " << sum << endl;
   }  
   // ***************************************************************************
   
   // ****            *****
   // ****     ********************************************
   cout << endl << "Saving info in new file null.txt..." << endl;
   ofstream out1("null.txt");
   for(unsigned j = 0; j < v.size(); j++) {
     bank_account b = v.at(j);
     double sum = 0;
      
     for(unsigned i = 0; i < b.getCommitments().size(); i++) {
        sum += b.getCommitments().at(i);
     }
     for(unsigned i = 0; i < b.getWithdraws().size(); i++) {
        sum -= b.getWithdraws().at(i);
     } 
     if(sum == 0)
      out1 << b; 
   }  
   out1.close();
   // ***************************************************************************
   
   system("PAUSE");
   return EXIT_SUCCESS;
}
